Hot News aus dem CAD.de-Newsletter:

Mit Unterstützung durch:

  Foren auf CAD.de (alle Foren)
  AutoCAD ObjectARX und .NET
  Hilfe bei der Fehlersuche

Antwort erstellen  Neues Thema erstellen
CAD.de Login | Logout | Profil | Profil bearbeiten | Registrieren | Voreinstellungen | Hilfe | Suchen

Anzeige:

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen nächster neuer Beitrag | nächster älterer Beitrag
Autor Thema:   Hilfe bei der Fehlersuche (76 mal gelesen)
tappenbeck
Mitglied
Vermessungsingenieur


Sehen Sie sich das Profil von tappenbeck an!   Senden Sie eine Private Message an tappenbeck  Schreiben Sie einen Gästebucheintrag für tappenbeck

Beiträge: 1102
Registriert: 30.05.2002

AutoCAD (Map)2015, Topobase, Lisp, .vb.net (Einsteiger)

erstellt am: 07. Dez. 2017 16:36    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Moin !

ich schreibe gerade in vb.net für Topobase ein Programm das einen Niv-Zug darstellen soll. Das Zeichnen der Linie erfolgt in der Funktion _TempAcadObj.DrawLine.

Am Ende einmal der gesamte Funktionscode.

Damit ich eine Linie zeichnen kann merke ich mir immer den letzten Punkt in der Variablen ZugPunktBefore.

Mein Problem ist nun in dem Codeabschnitt

Code:

PointCoord = _Geometrie.GetPointOfFeature(ZugPunktObj)
                                ZugPunkt.Y = PointCoord.Y
                                ZugPunkt.X = PointCoord.X

Sobald ich die Daten für das aktuelle Objekt ausgelesen habe und an PointCoord übergeben habe ändern sich die Daten für ZugPunkt, obwohl ZugPunktBefore erst weiter unten die Koordinten von ZugPunkt bekommt.

Irgendwie habe ich hier ein Brett vor dem ....

Vielleicht kann einer von Euch unten mal reinschauen.

Gruß Jan


Code:

Public Function GetNivZugPunkte(ByVal Item As Integer, Optional ByVal DrawPreview As Boolean = False, Optional ByRef Log As EBL.Service.Log = Nothing)
        Dim PointCoord As New Autodesk.Map.IM.Graphic.Point

        If Item < 1 Then Return -5

        If CheckRecordZug(Item) = 0 Then
            If Not IsNothing(Log) Then Log.Write("ungültiger NivZug mit der Nummer:=" & Item.ToString)
            Return 0
        End If

        Dim ZugBeginn As Integer = GetRecordZugBeginn(Item, Log)
        Dim ZugEnde As Integer = GetRecordZugEnde(Item, Log)

        Dim LastNr As String = ""
        Dim Old_Osmode As Integer = CInt(Autodesk.AutoCAD.ApplicationServices.Application.GetSystemVariable("OSMODE"))
        Autodesk.AutoCAD.ApplicationServices.Application.SetSystemVariable("OSMODE", 0)
        Dim ZugPunktBefore As Autodesk.Map.IM.Graphic.LinePoint = New Autodesk.Map.IM.Graphic.LinePoint
        Dim ZugPunkt As Autodesk.Map.IM.Graphic.LinePoint = New Autodesk.Map.IM.Graphic.LinePoint

        For i As Integer = ZugBeginn + 1 To ZugEnde - 1
            Try

                Dim DataLine As String = _M5Data(i).Trim()
                If DataLine.Length > 35 Then
                    Dim Data_PunktNr As String = DataLine.Substring(21, 29 - 22 + 1).Trim.ToUpper
                    Dim Data_VMarkung As String = DataLine.Substring(30, 4).Trim.ToUpper

                    If Data_PunktNr <> LastNr Then ' neuer Punkt
                        LastNr = Data_PunktNr ' jetzt ist das die letzte Nummer
                        ' schauen, ob Nummer aus der TB
                        Dim SQL As String = "select FID,ID_HERKUNFT, ID_PKTTYP, Z,BEM_NIGRA  from EBL_FEST_PUNKT where PUNKTNUMMER='" & Data_PunktNr & "'"
                        Dim MyDataAdapter As New Autodesk.Map.IM.Data.Provider.DataAdapter(SQL, _Document.Connection)
                        Dim Datentabelle As New System.Data.DataTable
                        MyDataAdapter.Fill(Datentabelle)

                        Dim ID_PKTTYP As Long = 0
                        Dim ID_HERKUNFT As Long = 0
                        Dim Z_Value As Double = k_Invalid_Höhe
                        Dim BEM_NIGRA As String = ""
                        Dim sFID As String = ""

                        If Datentabelle.Rows.Count = 1 Then
                            ID_PKTTYP = CLng(Datentabelle.Rows.Item(0).Item("ID_PKTTYP"))
                            ID_HERKUNFT = CLng(Datentabelle.Rows.Item(0).Item("ID_HERKUNFT"))

                            If Not IsDBNull(Datentabelle.Rows.Item(0).Item("Z")) Then
                                Z_Value = CDbl(Datentabelle.Rows.Item(0).Item("Z"))
                            End If

                            If Not IsDBNull(Datentabelle.Rows.Item(0).Item("BEM_NIGRA")) Then
                                BEM_NIGRA = Datentabelle.Rows.Item(0).Item("BEM_NIGRA")
                            End If
                            sFID = Datentabelle.Rows.Item(0).Item("FID")

                            If Data_VMarkung = "" Or Data_VMarkung = "0" Then
                                _Editor.WriteMessage("WP " & Data_PunktNr & vbCrLf)
                            Else
                                ' wenn ja, dann FID und Entfernung
                                _Editor.WriteMessage("HP " & Data_PunktNr & " - Vermarkung:= " & Data_VMarkung & " - FID:= " & sFID & vbCrLf)

                                Dim FeatureTabelle As Autodesk.Map.IM.Data.FeatureClass
                                FeatureTabelle = _Document.Connection.FeatureClasses.GetFeatureClassWithFID(CType(sFID, Long))
                                Dim ZugPunktObj As Autodesk.Map.IM.Data.Feature = FeatureTabelle.GetFeature(CType(sFID, Long))

                                PointCoord = _Geometrie.GetPointOfFeature(ZugPunktObj)
                                ZugPunkt.Y = PointCoord.Y
                                ZugPunkt.X = PointCoord.X

                                If i = ZugBeginn + 1 Then
                                    ZugPunktBefore = ZugPunkt
                                End If

                                If i > ZugBeginn + 1 Then
                                    _TempAcadObj.DrawLine(ZugPunktBefore, ZugPunkt, MapService.AcadTemporaryGraphics.TypeOfTempObjectList.Current)
                                    _TempAcadObj.AddCurrent2All()
                                    ZugPunktBefore = ZugPunkt
                                End If ' 2+ter Punkt im Zug


                                End If 'Wechselpunkt-Vermarkung


                        Else
                                ' ansonsten Wechselpunkt
                                _Editor.WriteMessage("WP " & Data_PunktNr & vbCrLf)

                        End If 'Tabelle Row

                    End If ' PunktNr <> Last

                End If
            Catch ex As Exception
                If Not IsNothing(Log) Then
                    Log.WriteAsError("Fehler beim der Suche nach dem Zugbeginn in Zeile " & (i + 1).ToString & vbCrLf & ex.ToString)
                End If
            End Try
        Next i


------------------
jan :-)

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4044
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools

erstellt am: 07. Dez. 2017 17:05    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für tappenbeck 10 Unities + Antwort hilfreich

Code:

ZugPunktBefore = new Point3d(ZugPunkt.X, ZugPunkt.Y, ZugPunkt.Z);


Mit der einfachen Zuweisung von
ZugPunktBefore = ZugPunkt;
setzt du den Zeiger von ZugPunktBefore auf den gleichen Zeiger wie ZugPunkt. Folglich ändert sich ZugPunktBefore auch, wenn sich ZugPunkt ändert.

Grüße!
Holger

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

tappenbeck
Mitglied
Vermessungsingenieur


Sehen Sie sich das Profil von tappenbeck an!   Senden Sie eine Private Message an tappenbeck  Schreiben Sie einen Gästebucheintrag für tappenbeck

Beiträge: 1102
Registriert: 30.05.2002

AutoCAD (Map)2015, Topobase, Lisp, .vb.net (Einsteiger)

erstellt am: 08. Dez. 2017 07:08    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities

Moin!

ich war der Meinung damit auch einen "Wert" zuweisen zu können - das ist ja sonst soetwas wie eine "Referenz".

Gruß Jan

------------------
jan :-)

Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP



Architekt/in (m/w) Hochbauingenieur/in (m/w)
np HomeHunting GmbH & Co. KG Firmenlogo, verlinkt auf www.np-homehunting.de Wir suchen zu sofort eine/n Architekt/in (m/w) Hochbauingenieur/in (m/w) in Teil- oder Vollzeit Seit nunmehr über 15 Jahren bauen wir moderne, energieeffiziente und schlüsselfertige Reihen- und Mehrfamilienhäuser in Schleswig-Holstein und Hamburg. Dabei stehen eine individuelle Beratung und der persönliche ...
Anzeige ansehenArchitektur
Brischke
Moderator
CAD on demand GmbH




Sehen Sie sich das Profil von Brischke an!   Senden Sie eine Private Message an Brischke  Schreiben Sie einen Gästebucheintrag für Brischke

Beiträge: 4044
Registriert: 17.05.2001

AutoCAD 20XX, defun-tools

erstellt am: 08. Dez. 2017 07:57    Editieren oder löschen Sie diesen Beitrag!  <-- editieren / zitieren -->   Antwort mit Zitat in Fett Antwort mit kursivem Zitat    Unities abgeben: 1 Unity (wenig hilfreich, aber dennoch)2 Unities3 Unities4 Unities5 Unities6 Unities7 Unities8 Unities9 Unities10 Unities Nur für tappenbeck 10 Unities + Antwort hilfreich

... Basics von .Net. Du arbeitest mit im Speicher abgelegten Objekten. Egel welcher Variable du nun den Zeiger auf diesen Speicher zuweist, es ist immer das gleiche Objekt, also der gleiche Speicherbereich.

Grüße!
Holger

------------------
Holger Brischke
CAD on demand GmbH
Individuelle Lösungen von Heute auf Morgen.


defun-tools Das Download-Portal für AutoCAD-Zusatzprogramme!


Eine Antwort auf diesen Beitrag verfassen (mit Zitat/Zitat des Beitrags) IP

Anzeige.:

Anzeige: (Infos zum Werbeplatz >>)

Darstellung des Themas zum Ausdrucken. Bitte dann die Druckfunktion des Browsers verwenden. | Suche nach Beiträgen

nächster neuerer Beitrag | nächster älterer Beitrag
Antwort erstellen


Diesen Beitrag mit Lesezeichen versehen ... | Nach anderen Beiträgen suchen | CAD.de-Newsletter

Administrative Optionen: Beitrag schliessen | Archivieren/Bewegen | Beitrag melden!

Fragen und Anregungen: Kritik-Forum | Neues aus der Community: Community-Forum

(c)2017 CAD.de